package io.rmuhamedgaliev.first.parser.impl;

import io.rmuhamedgaliev.first.parser.IParser;

import javax.swing.text.MutableAttributeSet;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.html.parser.ParserDelegator;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Set;
import java.util.TreeSet;

/**
 * @author Muhamedgaliev Rinat<rinat.muhamedgaliev@gmail.com>
 */
public class Parser implements IParser {
    static TreeSet domains = new TreeSet();
    static TreeSet links = new TreeSet();

    @Override
    public Reader getPage(String urlString) {
        URL url;
        InputStream is;
        BufferedReader br = null;
        try {
            if (urlString.isEmpty())
                throw new MalformedURLException();

            url = new URL(urlString);
            is = url.openStream();
            br = new BufferedReader(new InputStreamReader(is));
        } catch (MalformedURLException e) {
            System.err.print("Error urlString param");
        } catch (IOException e) {
            System.err.print("Error read page");
        }
        return br;
    }

    @Override
    public Set<String> pageParser(final Reader reader) throws IOException {
        ParserDelegator pDelegator = new ParserDelegator();
        HTMLEditorKit.ParserCallback pCallback = new HTMLEditorKit.ParserCallback() {
            public void handleText(final char[] data, final int pos) {
            }

            public void handleStartTag(HTML.Tag tag, MutableAttributeSet attribute, int pos) {
                if (tag == HTML.Tag.A) {
                    String address = (String) attribute.getAttribute(HTML.Attribute.HREF);
                    if (address != null &&  address.contains(".")) {
                        address = address.replaceAll("//", "");
                        StringBuilder builder;
                        if (address.contains("http:")) {
                            address = address.replaceAll("http:", "http://");
                        }
                        if (address.contains("https:")) {
                            address = address.replaceAll("https:", "https://");
                        }
                        if (!address.contains("http")) {
                            builder = new StringBuilder(address);
                            builder.insert(0, "http://");
                            address = builder.toString();
                        }
                        links.add(address);
                        URL url = null;
                        try {
                            url = new URL(address);
                            if (!domains.contains(url.getHost())) {
                                System.out.println(url.getHost());
                                domains.add(url.getHost());

                            }
                        } catch (MalformedURLException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }

            public void handleEndTag(HTML.Tag t, final int pos) {
            }

            public void handleSimpleTag(HTML.Tag t, MutableAttributeSet a, final int pos) {
            }

            public void handleComment(final char[] data, final int pos) {
            }

            public void handleError(final java.lang.String errMsg, final int pos) {
            }
        };
        pDelegator.parse(reader, pCallback, true);
        parser();
        return domains;
    }

    public void parser() {
        try {
            for (Object link: links) {
                URL url = new URL(link.toString());
                if (link.toString().split("\\.").length >= 3) {
                    Reader r = getPage(link.toString());
                    pageParser(r);
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }



}
