package io.rmuhamedgaliev.third.client;

import io.rmuhamedgaliev.third.client.service.IFileService;
import io.rmuhamedgaliev.third.client.service.impl.FileService;

import java.io.*;
import java.net.InetAddress;
import java.net.Socket;

/**
 * @author Muhamedgaliev Rinat<rinat.muhamedgaliev@gmail.com>
 */
public class Client {
    private static IFileService fileService = new FileService();

    public static void main(String[] args) {
        int serverPort = 7878;
        String address = "127.0.0.1";

        try {
            InetAddress ipAddress = InetAddress.getByName(address);
            Socket socket = new Socket(ipAddress, serverPort);
            InputStream sin = socket.getInputStream();
            OutputStream sout = socket.getOutputStream();
            DataInputStream in = new DataInputStream(sin);
            DataOutputStream out = new DataOutputStream(sout);
            BufferedReader keyboard = new BufferedReader(new InputStreamReader(System.in));
            String line = null;
            System.out.println();

            while (true) {
                line = keyboard.readLine();
                if (line.contains("get")) {
                    String[] params = line.split(" ");
                    if (params.length > 1) {
                        out.writeUTF(line);
                        out.flush();
                        String path = fileService.saveFile(sin, params[1]);
                        System.out.println("File saved at " + path);
                    }
                } else {
                    out.writeUTF(line);
                    out.flush();
                    line = in.readUTF();
                    System.out.println(line);
                }

            }
        } catch (Exception x) {
            x.printStackTrace();
        }
    }
}
