package io.rmuhamedgaliev.third.server;

import io.rmuhamedgaliev.third.server.service.IFileService;
import io.rmuhamedgaliev.third.server.service.impl.FileService;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * @author Muhamedgaliev Rinat<rinat.muhamedgaliev@gmail.com>
 */
public class Server {
    private static IFileService fileService = new FileService();
    private static String currentDir = fileService.currentDir();

    public static void main(String[] args) {
        int port = 7878;
        try {
            ServerSocket ss = new ServerSocket(port);
            Socket socket = ss.accept();
            InputStream sin = socket.getInputStream();
            OutputStream sout = socket.getOutputStream();

            DataInputStream in = new DataInputStream(sin);
            DataOutputStream out = new DataOutputStream(sout);

            String line = null;
            while(true) {
                line = in.readUTF();
                String[] params = line.split(" ");
                if (params.length > 0) {
                    if (params[0].equals("ls")) {
                        if (params.length == 1) {
                            line = fileService.listFiles(currentDir);
                        } else {
                            line = fileService.listFiles(params[1]);
                        }
                        out.writeUTF(line);
                        out.flush();
                    } else if (params[0].equals("cd")) {
                        if (params.length > 1) {
                            if (params[1].equals("..")) {
                                currentDir = fileService.parrentDirectory(currentDir);
                                line = currentDir;
                            } else {
                                String path = params[1];
                                currentDir = fileService.changeDirectory(currentDir, path);
                                line = currentDir.isEmpty() ? "File not exists" : currentDir;
                            }
                        } else {
                            line = "Use params:\n \"..\" - to parrent direcotry\n[full path] - to full change direcotry";
                        }
                        out.writeUTF(line);
                        out.flush();
                    } else if (params[0].equals("get")) {
                        String tempCurrentDir = currentDir;
                        if (params.length > 1) {
                            byte[] file = fileService.sendFile(currentDir, params[1]);
                            sout.write(file, 0, file.length);
                        }
                        out.flush();
                        currentDir = tempCurrentDir;
                    } else {
                        line = "use follow commands: ls - list files\ncd - change directory";
                        out.writeUTF(line);
                        out.flush();
                    }
                } else {
                    line = "Command can't be empty";
                    out.writeUTF(line);
                    out.flush();
                }
            }
        } catch(Exception x) { x.printStackTrace(); }
    }
}
