package io.rmuhamedgaliev.third.server.service.impl;

import io.rmuhamedgaliev.third.server.service.IFileService;

import java.io.*;
import java.nio.file.Paths;

/**
 * @author Muhamedgaliev Rinat<rinat.muhamedgaliev@gmail.com>
 */
public class FileService implements IFileService {
    @Override
             public String listFiles(String path) {
        File folder = new File(path);
        StringBuffer reslut = new StringBuffer("Current directory is: \n")
                .append(folder.getAbsolutePath()).append("\n");
        File[] listOfFiles = folder.listFiles();

        for (int i = 0; i < listOfFiles.length; i++) {
            if (listOfFiles[i].isFile()) {
                reslut.append(listOfFiles[i].getName()).append("\n");
            } else if (listOfFiles[i].isDirectory()) {
                reslut.append(listOfFiles[i].getName()).append("/\n");
            }
        }
        return reslut.toString();
    }

    @Override
    public String currentDir() {
        return Paths.get("").toAbsolutePath().toString();
    }

    @Override
    public String changeDirectory(String currentDirectory, String s) {
        File file = new File(s);
        if (!s.contains(":")) {
            file = new File(currentDirectory + "/" + s);
        }
        if (file.exists()) {
            return file.getAbsolutePath();
        }
        return "";
    }

    @Override
    public String parrentDirectory(String currentDirectory) {
        File file = new File(currentDirectory);
        file = new File(file.getParent());
        if (!file.exists()) {
            return "File not exists";
        }
        return file.getAbsolutePath();
    }

    @Override
    public byte[] sendFile(String currentDirectory, String fileName) throws IOException {
        File file = new File(currentDirectory + "/" + fileName);
        if (file.exists()) {
            byte[] fileByte = new byte[(int) file.length()];
            BufferedInputStream bis = new BufferedInputStream(new FileInputStream(file));
            bis.read(fileByte, 0, fileByte.length);
            return fileByte;
        }
        return new byte[0];
    }
}
